/* Copyright (c) 2008, Florent FAYOLLE


This file is part of Zenith

Zenith is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/* Implementation file */
#include "Him.h"
#define	MIN(x,y)	(((x)<(y))?(x):(y))
#define	MAX(x,y)	(((x)>(y))?(x):(y))
#define HIM_NORMAL	0
#define HIM_CANCEL_ACTION	1
#define MAX_MOVE 	2



NS_IMPL_ISUPPORTS1(Him, IHim)
Him::Him()
{
	
	regX = regY = -1;
	
  /* member initializers and constructor code */
}

Him::~Him()
{
  /* destructor code */
}

/* void MoveCursorTo (in unsigned short posX, in unsigned short posY); */
NS_IMETHODIMP Him::MouseMove(PRInt16 posX, PRInt16 posY, PRInt16 *status)
{
	int min = MIN(abs(posX),abs(posY)), i, a=((posX>0)?1:-1), b=((posY>0)?1:-1);

	
	GetCursorPos(&pos);
	// we see where the pointer is in the screen
	for(i=0; i<min;i++){
		SetCursorPos(pos.x+a,pos.y+b);
		
		
		if(detectMouseMove()){
			*status = HIM_CANCEL_ACTION;
			//XCloseDisplay(display);
			return NS_OK;
		}
		
		Msleep(4);
	}
	a*=(abs(posX)>abs(posY)); b*=(abs(posX)<abs(posY));//abs(a)=1 && b=0 if x>y, abs(b)=1 && a=0 if y>x
	for(i=0; i<MAX(abs(posX),abs(posY))-min;i++){
		if(detectMouseMove()){
			*status = HIM_CANCEL_ACTION;
			//XCloseDisplay(display);
			return NS_OK;
		}
		SetCursorPos(pos.x+a,pos.y+b);
		Msleep(4);
		
	}
	regX = regY = -1;
	*status = HIM_NORMAL;
	//XCloseDisplay(display);
	return NS_OK;
}
NS_IMETHODIMP Him::DetectMouseMove(int* res){
	*res = detectMouseMove();
	return NS_OK;
}
bool Him::detectMouseMove(){
	GetCursorPos(&pos);
	int curX = pos.x, curY = pos.y;
	if(regX>0 && regY>0 && (abs(curX-regX) >MAX_MOVE || abs(curY-regY)>MAX_MOVE)){
		//printf("la souris a boug");
		regX = regY = -1;
		return true;
	}
	regX = curX;
	regY = curY;
	return false;
}
NS_IMETHODIMP Him::ResetReg(){
	regX = regY = -1;
	return NS_OK;
}
NS_IMETHODIMP Him::Msleep(PRInt16 time){
  Sleep(time);
  return NS_OK;
}

NS_IMETHODIMP Him::Msleep2(PRInt16 time, PRInt16* status){
	int i;
	for(i=0; i<time/100; i++){
		Msleep(100);
		if(detectMouseMove()){
			*status =  HIM_CANCEL_ACTION; 
			return NS_OK;
		}
	}
	Msleep(time-100*((int)time/100));
	return NS_OK;
}

NS_IMETHODIMP Him::GetMousePosition(PRInt16* posX, PRInt16* posY){
	//XQueryPointer(display, RootWindow(display, DefaultScreen(display)), &event.xbutton.root, &event.xbutton.window, &event.xbutton.x_root, &event.xbutton.y_root, &event.xbutton.x, &event.xbutton.y, &event.xbutton.state);
	GetCursorPos(&pos);
	*posX = pos.x;
	*posY = pos.y;
	return NS_OK;
}
NS_IMETHODIMP Him::SetCursorTo(PRInt16 x, PRInt16 y){
	SetCursorPos(x,y);
	return NS_OK;
}

NS_IMETHODIMP Him::Click(PRInt16 button){                                                                      
        //Display *display = XOpenDisplay(NULL);     
	switch(button){
		case 1: // button left
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0,0,0,0);
			Sleep(100);
			mouse_event(MOUSEEVENTF_LEFTUP, 0,0,0,0);
			break;
		case 2:
			mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0,0,0,0);
			Sleep(100);
			mouse_event(MOUSEEVENTF_MIDDLEUP, 0,0,0,0);
			break;
		case 3:
			mouse_event(MOUSEEVENTF_RIGHTDOWN, 0,0,0,0);
			Sleep(100);
			mouse_event(MOUSEEVENTF_RIGHTUP, 0,0,0,0);
			break;
	}

  return NS_OK;
}